.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_LINK.9,v 1.1.2.2 1999/09/05 11:27:12 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_LINK 9
.Sh NAME
.Nm VOP_LINK
.Nd create a new name for a file
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Ft int
.Fn VOP_LINK "struct vnode *dvp" "struct vnode *vp" "struct componentname *cnp"
.Sh DESCRIPTION
This links a new name in the specified directory to an existing file.
.Pp
Its arguments are:
.Bl -tag -width 8X
.It Ar dvp
the vnode of the directory
.It At vp
the vnode of the file to be linked
.It Ar cnp
pathname information about the file
.El
.Pp
The directory vnode is unlocked and released on exit.
.Sh LOCKS
The directory,
.Fa dvp
should be locked on entry and will be unlocked and released on exit.
The file
.Fa vp
should not be locked.
.Sh RETURN VALUES
Zero is returned if the file was linked successfully, otherwise an
error is returned.
.Sh PSEUDOCODE
.Bd -literal
int
vop_link(struct vnode *dvp, struct vnode *vp, struct componentname *cnp)
{
    int error = 0;

    if (vp->v_mount != dvp->v_mount) {
	VOP_ABORTOP(dvp, cnp);
	error = EXDEV;
	goto out2;
    }
    if (vp != dvp && (error = VOP_LOCK(vp))) {
	VOP_ABORTOP(dvp, cnp);
	goto out2;
    }

    if (vp would have too many links) {
	VOP_ABORTOP(dvp, cnp);
	error = EMLINK;
	goto out1;
    }

    if (vp is immutable) {
	VOP_ABORTOP(dvp, cnp);
	error = EPERM;
	goto out1;
    }

    /*
     * Increment link count of vp and write back the on-disc version of it.
     */
    ...;

    if (!error) {
	/*
	 * Add the new name to the directory.
	 */
	...;
    }

    free(cnp->cn_pnbuf, M_NAMEI);
out1:
    if (vp != dvp)
	VOP_UNLOCK(vp);
out2:
    vput(dvp);

    return error;
}
.Ed
.Sh ERRORS
.Bl -tag -width Er
.It Bq Er EPERM
the file is immutable
.El
.Sh SEE ALSO
.Xr vnode 9
.Sh AUTHORS
This man page was written by Doug Rabson.
